<?php
if (!defined('CC_INI_SET')) die('Access Denied');
Admin::getInstance()->permissions(array('products', 'categories'), CC_PERM_READ, true);

global $lang;

## Set Archive directory
$archive_root	= CC_ROOT_DIR.CC_DS.'includes'.CC_DS.'extra';
if (isset($_POST['export'])) {
	Admin::getInstance()->permissions('products', CC_PERM_EDIT, true);
	ini_set('ignore_user_abort', true);
	ini_set('max_execution_time', 30);
	/*
	* Create a new CubeCart inventory archive
	* Includes an XML file containing all categories, options, tax rules, products
	* As well as adding all images
	*/
	$created = date('c');
	$archive = new Archive($archive_root.CC_DS.'archive_'.date('Y-m-d.Hi').'.zip', true);
	findFiles($list, CC_ROOT_DIR.CC_DS.'images'.CC_DS.'source');
	if (!empty($list)) {
		$archive->add($list);
		unset($list);
	}
	##########################################
	## Start XML document
	$xml	= new XMLWriter();
	$xml->openMemory();
	$xml->startDocument('1.0', 'UTF-8');
	$xml->startElement('inventory');
	$xml->writeAttribute('version', '1.0');
	$xml->writeAttribute('created', $created);
	##########################################
	## Info header
	$xml->startElement('info');
	$xml->writeElement('version', CC_VERSION);
	$xml->writeElement('created', $created);
	$xml->endElement();
	##########################################
	## CATEGORIES
	if (($categories = $GLOBALS['db']->select('CubeCart_category')) !== false) {
		$xml->startElement('categories');
		foreach ($categories as $category) {
			$xml->startElement('category');
			$xml->writeAttribute('cat_id', (int)$category['cat_id']);
			$xml->writeAttribute('parent_id', (int)$category['cat_parent_id']);
			$xml->writeAttribute('status', (int)$category['status']);
			$xml->writeAttribute('priority', (int)$category['priority']);
			foreach ($category as $name => $value) {
				if (!empty($value) && in_array($name, array('cat_name', 'cat_desc', 'per_ship', 'per_int_ship', 'item_ship', 'item_int_ship'))) $xml->writeElement($name, $value);
			}
			$xml->endElement();
		}
		$xml->endElement();
		unset($categories, $category, $name, $value);
	}
	##########################################
	## OPTIONS
	if (($options = $GLOBALS['db']->select('CubeCart_option_group')) !== false) {
		$xml->startElement('options');
		foreach ($options as $option) {
			$xml->startElement('option');
			$xml->writeAttribute('option_id', (int)$option['option_id']);
			$xml->writeAttribute('type', (int)$option['option_type']);
			$xml->writeAttribute('required', (int)$option['option_required']);
			##
			$xml->startElement('name');
			$xml->writeCData($option['option_name']);
			$xml->endElement();
			if (!empty($option['option_description'])) {
				$xml->startElement('description');
				$xml->writeCData($option['option_description']);
				$xml->endElement();
			}
			if ($option['option_type'] == 0) {
				$children	= $GLOBALS['db']->select('CubeCart_option_value', array('value_id', 'value_name'), array('option_id' => $option['option_id']), array('value_name' => 'ASC'));
				if ($children) {
					$xml->startElement('values');
					foreach ($children as $child) {
						$xml->startElement('value');
						$xml->writeAttribute('value_id', (int)$child['value_id']);
						$xml->writeCData($child['value_name']);
						$xml->endElement();
					}
					$xml->endElement();
				}
			}
			$xml->endElement();
		}
		$xml->endElement();
		unset($options, $option, $children, $child);
	}
	##########################################
	## TAX TABLES
	$xml->startElement('taxes');
	## Types
	if (($tax_types = $GLOBALS['db']->select('CubeCart_tax_class')) !== false) {
		$xml->startElement('types');
		foreach ($tax_types as $tax) {
			$xml->startElement('type');
			$xml->writeAttribute('id', (int)$tax['id']);
			$xml->writeCData($tax['tax_name']);
			$xml->endElement();
		}
		$xml->endElement();
		unset($tax_types, $tax);
	}
	## Details
	if (($tax_details = $GLOBALS['db']->select('CubeCart_tax_details')) !== false) {
		$xml->startElement('details');
		foreach ($tax_details as $detail) {
			$xml->startElement('detail');
			$xml->writeAttribute('detail_id', (int)$detail['id']);
			$xml->writeAttribute('status', (int)$detail['status']);
			##
			$xml->startElement('name');
			$xml->writeCData($detail['name']);
			$xml->endElement();
			#
			$xml->startElement('display');
			$xml->writeCData($detail['display']);
			$xml->endElement();
			#
			$xml->startElement('reg_number');
			$xml->writeCData($detail['reg_number']);
			$xml->endElement();
			$xml->endElement();
		}
		$xml->endElement();
		unset($tax_details, $detail);
	}
	## Rates
	if (($tax_rates = $GLOBALS['db']->select('CubeCart_tax_rates')) !== false) {
		$xml->startElement('rates');
		foreach ($tax_rates as $rate) {
			$xml->startElement('rate');
			$xml->writeAttribute('rate_id', (int)$rate['id']);
			$xml->writeAttribute('type_id', (int)$rate['type_id']);
			$xml->writeAttribute('details_id', (int)$rate['details_id']);
			$xml->writeAttribute('active', (int)$rate['active']);
			##
			$xml->writeElement('country_id', (int)$rate['country_id']);
			$xml->writeElement('tax_percent', (int)$rate['tax_percent']);
			##
			$xml->writeElement('goods', (int)$rate['goods']);
			$xml->writeElement('shipping', (int)$rate['shipping']);
			$xml->endElement();
		}
		$xml->endElement();
		unset($tax_rates, $rate);
	}
	$xml->endElement('taxes');
	##########################################
	## MANUFACTURERS
	if (($manufacturers = $GLOBALS['db']->select('CubeCart_manufacturers')) !== false) {
		$xml->startElement('manufacturers');
		foreach ($manufacturers as $manufacturer) {
			$xml->startElement('manufacturer');
			$xml->writeAttribute('id', (int)$manufacturer['id']);
			$xml->writeAttribute('image', (int)$manufacturer['image']);
			$xml->writeAttribute('name', (int)$manufacturer['name']);
			$xml->writeCData($manufacturer['URL']);
			$xml->endElement();
		}
		$xml->endElement();
		unset($manufacturers, $manufacturer);
	}
	##########################################
	## INVENTORY
	if (($products = $GLOBALS['db']->select('CubeCart_inventory')) !== false) {
		$xml->startElement('products');
		foreach ($products as $i => $product) {
			$xml->startElement('product');
			$xml->writeAttribute('product_id', (int)$product['product_id']);
			$xml->writeAttribute('date_added', (string)$product['date_added']);
			$xml->writeAttribute('status', $product['status'] ? 1:0);
			$xml->writeAttribute('digital', $product['digital'] ? 1:0);
			$xml->writeAttribute('featured', $product['featured'] ? 1:0);
			$xml->writeAttribute('popularity', (int)$product['popularity']);
			$xml->writeAttribute('tax_type', (int)$product['tax_type']);
			$xml->writeAttribute('tax_inclusive', $product['tax_inclusive'] ? 1:0);
			$ignore		= array('product_id', 'date_added', 'status', 'digital', 'featured', 'popularity', 'tax_type', 'tax_inclusive');
			foreach ($product as $name => $value) {
				if (!empty($value) && !in_array($name, $ignore)) {
					$xml->startElement($name);
					$xml->writeCData($value);
					$xml->endElement();
				}
			}
			## Categories
			if (($categories = $GLOBALS['db']->select('CubeCart_category_index', false, array('product_id' => $product['product_id']))) !== false) {
				$xml->startElement('categories');
				foreach ($categories as $category) {
					$xml->startElement('category');
					$xml->writeAttribute('cat_id', (int)$category['cat_id']);
					$xml->writeAttribute('primary', (int)$category['primary']);
					$xml->endElement();
				}
				$xml->endElement();
				unset($categories, $category);
			}
			## Product Options
			if (($options = $GLOBALS['db']->select('CubeCart_option_assign', false, array('product' => $product['product_id']))) !== false) {
				$xml->startElement('options');
				foreach ($options as $option) {
					$xml->startElement('option');
					$xml->writeAttribute('assign_id', (int)$option['assign_id']);
					$xml->writeAttribute('option_id', (int)$option['option_id']);
					$xml->writeAttribute('value_id', (int)$option['value_id']);
					$xml->writeAttribute('product_id', (int)$option['product']);
					$xml->writeElement('name', $option['name']);
					$xml->writeElement('description', $option['descritpion']);
					$xml->endElement();
				}
				$xml->endElement();
				unset($options, $option);
			}
			## Images
			if (($images = $GLOBALS['db']->select('CubeCart_image_index', false, array('product_id' => $product['product_id']))) !== false) {
				$xml->startElement('images');
				foreach ($images as $image) {
					$xml->startElement('image');
					$xml->writeAttribute('default', $image['main_img'] ? 1 : 0);
					$xml->writeAttribute('image_id', (int)$image['id']);
					$xml->writeAttribute('file_id', (int)$image['file_id']);
					$xml->writeCData($image['img']);
					$xml->endElement();
				}
				$xml->endElement();
				unset($images, $image);
			}
			$xml->endElement();
			unset($products[$i], $product);
		}
		$xml->endElement();
		unset($products);
	}
	## End document
	$xml->endElement();
	$xml->endDocument();
	## Output data, and add to archive
	$archive->add('inventory.xml', $xml->outputMemory(true));
	unset($xml);
	## Redirect, and display a completion message, with a link to the download
	$GLOBALS['main']->setACPNotify($lang['settings']['notify_archive_create']);

	httpredir(currentPage(), 'archive');
} else if (isset($_POST['import'])) {
	Admin::getInstance()->permissions('products', CC_PERM_FULL, true);
	if (isset($_FILES['archive']) && is_uploaded_file($_FILES['archive']['tmp_name']) || isset($_POST['archive']) && !empty($_POST['archive'])) {
		if (isset($_FILES['archive']) && !empty($_FILES['archive']['tmp_name']) && is_uploaded_file($_FILES['archive']['tmp_name'])) {
			$file	= $_FILES['archive']['tmp_name'];
		} else if (file_exists($archive_root.CC_DS.basename($_POST['archive']))) {
			$file	= $archive_root.CC_DS.basename($_POST['archive']);
		} else {
			httpredir(currentPage());
		}
		if (file_exists($file)) {
			$archive	= new Archive($file);
			## lets open the archive, and read in the xml file
			$data	= $archive->read('inventory.xml');
			$xml	= new simpleXMLElement($data);
			## Insert Categories
			if ($xml->categories) {
				$GLOBALS['db']->truncate('CubeCart_category');
				foreach ($xml->categories->category as $category) {
					$record	= array(
						'cat_id'			=> (int)$category->attributes()->cat_id,
						'cat_parent_id'		=> (int)$category->attributes()->parent_id,
						'status'			=> (int)$category->attributes()->status,
						'priority'			=> (int)$category->attributes()->priority,
						'cat_name'			=> (string)$category->cat_name,
						'cat_desc'			=> isset($category->cat_desc) ? (string)$category->cat_desc : '',
						'per_ship'			=> (string)$category->per_ship,
						'per_int_ship'		=> (string)$category->per_int_ship,
						'item_ship'			=> (string)$category->item_ship,
						'item_int_ship'		=> (string)$category->item_int_ship,
					);
					$GLOBALS['db']->insert('CubeCart_category', $record);
				}
			}
			## Insert Options
			if ($xml->options) {
				$GLOBALS['db']->truncate('CubeCart_option_group');
				$GLOBALS['db']->truncate('CubeCart_option_value');
				foreach ($xml->options->option as $option) {
					$record	= array(
						'option_id'				=> (int)$option->attributes()->option_id,
						'option_name'			=> (string)$option->name,
						'option_description'	=> (string)$option->description,
						'option_type'			=> (int)$option->attributes()->type,
						'option_required'		=> (int)$option->attributes()->required,
					);
					$GLOBALS['db']->insert('CubeCart_option_group', $record);
					if ($option->values) {
						foreach ($option->values->value as $value) {
							$record	= array(
								'value_id'		=> (int)$value->attributes()->value_id,
								'option_id'		=> (int)$option->attributes()->option_id,
								'value_name'	=> (string)$value,
							);
							$GLOBALS['db']->insert('CubeCart_option_value', $record);
						}
					}
				}
			}
			## Insert Tax Rules
			if ($xml->taxes) {
				if ($xml->taxes->types) {
					$GLOBALS['db']->truncate('CubeCart_tax_class');
					foreach ($xml->taxes->types->type as $tax_type) {
						$record	= array(
							'id'		=> (int)$tax_type->attributes()->id,
							'tax_name'	=> (string)$tax_type,
						);
						$GLOBALS['db']->insert('CubeCart_tax_class', $record);
					}
				}
				if ($xml->taxes->details) {
					$GLOBALS['db']->truncate('CubeCart_tax_details');
					foreach ($xml->taxes->details->detail as $detail) {
						$record	= array(
							'id'			=> (int)$detail->attributes()->detail_id,
							'status'		=> (int)$detail->attributes()->status,
							'name'			=> (string)$detail->name,
							'display'		=> (string)$detail->display,
							'reg_number'	=> (string)$detail->reg_number,
						);
						$GLOBALS['db']->insert('CubeCart_tax_details', $record);
					}
				}
				if ($xml->taxes->rates) {
					$GLOBALS['db']->truncate('CubeCart_tax_rates');
					foreach ($xml->taxes->rates->rate as $tax_rate) {
						$record	= array(
							'id'			=> (int)$tax_rate->attributes()->rate_id,
							'active'		=> (int)$tax_rate->attributes()->active,
							'type_id'		=> (int)$tax_rate->attributes()->type_id,
							'details_id'	=> (int)$tax_rate->attributes()->details_id,
							'country_id'	=> (int)$tax_rate->country_id,
							'tax_percent'	=> (string)$tax_rate->tax_percent,
							'goods'			=> ($tax_rate->goods) ? 1 : 0,
							'shipping'		=> ($tax_rate->shipping) ? 1 : 0,
						);
						$GLOBALS['db']->insert('CubeCart_tax_rates', $record);
					}
				}
			}
			## Insert Manufacturers
			if ($xml->manufacturers) {
				$GLOBALS['db']->truncate('CubeCart_manufacturers');
				foreach ($xml->manufacturers->manufacturer as $manufacturer) {
					$record	= array(
						'id'	=> (int)$manufacturer->attributes()->id,
						'name'	=> (string)$manufacturer->attributes()->name,
						'URL'	=> (string)$manufacturer,
						'image'	=> (int)$manufacturer->attributes()->image,
					);
					$GLOBALS['db']->insert('CubeCart_manufacturers', $record);
				}
				unset($record, $manufacturer);
			}

			## Insert Products
			if ($xml->products) {
				$GLOBALS['db']->truncate('CubeCart_inventory');
				$GLOBALS['db']->truncate('CubeCart_option_assign');
				$GLOBALS['db']->truncate('CubeCart_category_index');
				$GLOBALS['db']->truncate('CubeCart_image_index');
				foreach ($xml->products->product as $product) {
					$record	= array(
						'product_id'		=> (int)$product->attributes()->product_id,
						'date_added'	=> (string)$product->attributes()->date_added,
						'popularity'	=> (int)$product->attributes()->popularity,
						'status'		=> $product->attributes()->status ? '1' : '0',
						# Details
						'name'			=> (string)$product->name,
						'product_code'	=> (string)$product->product_code,
						'description'	=> (string)$product->description,
						'eanupc_code'	=> (string)$product->eanupc_code,
						# Price & Weight
						'price'			=> (float)$product->price,
						'sale_price'	=> (float)$product->sale_price,
						'tax_type'		=> (int)$product->attributes()->tax_type,
						'tax_inclusive'	=> $product->attributes()->tax_inclusive ? 1 : 0,
						'product_weight'=> (float)$product->product_weight,
						# Stock
						'use_stock_level'	=> $product->use_stock_level ? 1 : 0,
						'stock_level'	=> (int)$product->stock_level,
						'stock_warning'		=> (int)$product->stock_warning,
						'featured'		=> $product->attributes()->featured ? 1 : 0,
						# Digital
						'digital'		=> $product->attributes()->digital ? 1 : 0,
						'digital_path'	=> (string)$product->digital_path,
						# SEO
						'seo_meta_title'		=> (string)$product->seo_meta_title,
						'seo_meta_description'	=> (string)$product->seo_meta_description,
						'seo_meta_keywords'		=> (string)$product->seo_meta_keywords,
					);
					$GLOBALS['db']->insert('CubeCart_inventory', $record);
					if ($product->options) {
						foreach ($product->options->option as $option) {
							$record	= array(
								'assign_id'		=> (int)$option->attributes()->assign_id,
								'product'		=> (int)$option->attributes()->product_id,
								'option_id'		=> (int)$option->attributes()->option_id,
								'value_id'		=> (int)$option->attributes()->value_id,
								'option_value'	=> (float)$option->option_value,
								'option_weight'	=> (float)$option->option_weight,
								//'option_stock'	=> (int)$option->option_stock,
							);
							$GLOBALS['db']->insert('CubeCart_option_assign', $record);
						}
					}
					if ($product->categories) {
						foreach ($product->categories->category as $category) {
							$record	= array(
								'cat_id'	=> (int)$category->attributes()->cat_id,
								'product_id'	=> (int)$product->attributes()->product_id,
								'primary'	=> $category->attributes()->primary ? 1 : 0,
							);
							$GLOBALS['db']->insert('CubeCart_category_index', $record);
						}
					}
					if ($product->images) {
						foreach ($product->images->image as $image) {
							$record	= array(
								'id'		=> (int)$image->attributes()->image_id,
								'product_id'	=> (int)$product->attributes()->product_id,
								'file_id'	=> (int)$image->attributes()->file_id,
								'main_img'	=> $image->attributes()->default ? 1 : 0,
								'img'		=> (string)$image,
							);
							$GLOBALS['db']->insert('CubeCart_image_index', $record);
						}
					}
				}
			}
			## Extract images to the correct folder
			$archive->extract(CC_ROOT_DIR);
			unlink(CC_ROOT_DIR.CC_DS.'inventory.xml');
			## Redirect on success
			$GLOBALS['main']->setACPNotify($lang['settings']['notify_archive_restore']);
			httpredir(currentPage(), 'archive');
		}
	}
	## Falls back to here
	$GLOBALS['main']->setACPWarning($lang['settings']['error_archive_restore']);
} else {
	if (isset($_GET['delete']) && Admin::getInstance()->permissions(array('products','categories'), CC_PERM_DELETE)) {
		if (file_exists($archive_root.CC_DS.$_GET['delete']) && unlink($archive_root.CC_DS.$_GET['delete'])) {
			$GLOBALS['main']->setACPNotify($lang['settings']['notify_archive_delete']);
			httpredir(currentPage(array('delete')));
		} else {
			$GLOBALS['main']->setACPWarning($lang['settings']['error_archive_delete']);
			httpredir(currentPage(array('delete')));
		}
	}

	$GLOBALS['gui']->addBreadcrumb($lang['settings']['title_archives']);
	$GLOBALS['main']->addTabControl('Archive', 'archive');

	## list existing archives
	$archives	= glob($archive_root.CC_DS.'archive_*.zip');
	if ($archives) {
		rsort($archives);
		foreach ($archives as $archive) {
			$smarty_data['archives'][]	= array('file' => str_replace(CC_ROOT_DIR.CC_DS, '', $archive), 'name' => basename($archive), 'size' => format_size(filesize($archive)), 'delete' => currentPage(null, array('delete' => basename($archive))));
		}
		$page_content = $GLOBALS['smarty']->assign('ARCHIVES',$smarty_data['archives']);
	}
	$page_content = $GLOBALS['smarty']->fetch('templates/products.archive.php');
}