<?php
$regex_slash_keep = '#[^\w\.\-\_\/]#i';
$regex_slash_remove = '#[^\w\.\-\_]#i';

## Update homepage data
$short_lang_identifier = (empty($_SESSION['setup']['short_lang_identifier'])) ? 'en' : $_SESSION['setup']['short_lang_identifier'];

switch($short_lang_identifier) {
	case 'cn':
		$_SESSION['setup']['long_lang_identifier'] = 'cn-CN';
	break;
	case 'de':
		$_SESSION['setup']['long_lang_identifier'] = 'de-DE';
	break;
	case 'dk':
		$_SESSION['setup']['long_lang_identifier'] = 'dk-DK';
	break;
	case 'en':
		$_SESSION['setup']['long_lang_identifier'] = 'en-US';
	break;
	case 'es':
		$_SESSION['setup']['long_lang_identifier'] = 'es-ES';
	break;
	case 'fi':
		$_SESSION['setup']['long_lang_identifier'] = 'fi-FI';
	break;
	case 'fr':
		$_SESSION['setup']['long_lang_identifier'] = 'fr-FR';
	break;
	case 'it':
		$_SESSION['setup']['long_lang_identifier'] = 'it-IT';
	break;
	case 'nl':
		$_SESSION['setup']['long_lang_identifier'] = 'nl-NL';
	break;
	case 'no':
		$_SESSION['setup']['long_lang_identifier'] = 'no-NO';
	break;
	case 'pl':
		$_SESSION['setup']['long_lang_identifier'] = 'pl-PL';
	break;
	case 'pt':
		$_SESSION['setup']['long_lang_identifier'] = 'pt-PT';
	break;
	case 'se':
		$_SESSION['setup']['long_lang_identifier'] = 'se-SE';
	break;
	case 'sk':
		$_SESSION['setup']['long_lang_identifier'] = 'sk-SK';
	break;
	default:
		$_SESSION['setup']['long_lang_identifier'] = 'en-US';
}

if ($homepage = $db->select('CubeCart_lang', false, array('identifier' => '/'.$short_lang_identifier.'/home.inc.php'))) {
	$data	= unserialize($homepage[0]['langArray']);
	$record	= array(
		'doc_lang'		=> $_SESSION['setup']['long_lang_identifier'],
		'doc_home'		=> 1,
		'doc_name'		=> $data['title'],
		'doc_content'	=> $data['copy'],
		'seo_meta_title'		=> $data['doc_metatitle'],
		'seo_meta_description'	=> $data['doc_metadesc'],
		'seo_meta_keywords'		=> $data['doc_metakeywords'],
	);
	$db->insert('CubeCart_documents', $record);
} else {
	$lang_path = CC_ROOT_DIR.CC_DS.'language'.CC_DS.$short_lang_identifier.CC_DS.'home.inc.php';
	if(file_exists($lang_path)) {
		include($lang_path);
		$record	= array(
				'doc_lang'		=> $_SESSION['setup']['long_lang_identifier'],
				'doc_home'		=> 1,
				'doc_name'		=> $home['title'],
				'doc_content'	=> $home['copy'],
			);
		$db->insert('CubeCart_documents', $record);
	}
}

$from	= CC_ROOT_DIR.CC_DS.'images'.CC_DS.'uploads';
$to		= CC_ROOT_DIR.CC_DS.'images'.CC_DS.'source';
if (file_exists($from) && file_exists($to)) {
	## Delete the images/source/ folder from the upload (it should be empty)
	rmdir($to);
} /*else {
	$errors[] = $strings['setup']['error_rename_images'];
}*/
if (file_exists($from) && is_writable(dirname($from))) {
	if (!file_exists($to) && rename($from, $to)) {
		## Delete thumbs/ dir recursively
		recursiveDelete($to.CC_DS.'thumbs');
	} else {
		## NOTIFY: They need to update manually
		$errors[] = $strings['setup']['error_rename_images'];
	}
}

## rename images and folder acordingly
$existing_images	= glob_recursive(CC_ROOT_DIR.CC_DS.'images'.CC_DS.'source'.CC_DS.'*');
if(is_array($existing_images)) {
	foreach($existing_images as $existing_image) {
		rename($existing_image,preg_replace($regex_slash_keep, '_',$existing_image));
	}	
}
unset($existing_images);

## Format filenames
include $global_file; // Just to make sure we have it
$product_files = $db->select('CubeCart_inventory',array('image','product_id'));
if($product_files) {
	foreach($product_files as $file) {		
		$db->misc("UPDATE `".$glob['dbprefix']."CubeCart_inventory` SET `image` = '".preg_replace($regex_slash_keep, '_', $file['image'])."' WHERE `product_id` = '".$file['product_id']."'");
	}
}

$filemanager_files = $db->select('CubeCart_filemanager',array('filepath','filename','file_id'));
if($filemanager_files) {
	foreach($filemanager_files as $file) {		
		$db->misc("UPDATE `".$glob['dbprefix']."CubeCart_filemanager` SET `filepath` = '".preg_replace($regex_slash_keep, '_', $file['filepath'])."', `filename` = '".preg_replace($regex_slash_remove, '_', $file['filename'])."' WHERE `file_id` = '".$file['file_id']."'");
	}
}
unset($product_files,$filemanager_files);

## Update FileManager table first 
$fm = new FileManager();
$fm->buildDatabase();

$v4config = Config::getInstance()->get('config');
foreach (glob('..'.CC_DS.'images'.CC_DS.'logos'.CC_DS.'*') as $file) {
    if(!preg_match('/[.][a-z]{3}/',$file,$match)) {
    	$mime = $fm->getMimeType($file);
		$size = getimagesize($file);
		if(preg_match('/(png|jpg|jpeg|gif)/',$mime,$match)) {
    		$match[0] = ($match[0]=='jpeg') ? 'jpg' : $match[0];
    		$new_name = $file.'.'.$match[0];
    		chmod($file, chmod_writable());
    		rename($file, $new_name);
    		chmod($new_name, chmod_writable());
       	}
       	$file_name = preg_replace('/..\/images\/logos\//','',$file);
       	$new_file_name = preg_replace('/..\/images\/logos\//','',$new_name);
   		if($file_name==$v4config['skinDir']) {
   			$db->insert('CubeCart_logo',array('status' => 1, 'filename' => $new_file_name, 'mimetype' => $mime, 'width' => $size[0], 'height' => $size[1]));
   		}
    }
}
build_logos($new_file_name);

## Remap store country from id to numcode
$country = $db->select('CubeCart_geo_country', array('numcode'), array('id' => $v4config['siteCountry']));
Config::getInstance()->set('config','store_country',$country[0]['numcode']);

## Create new image indexes for main images
if ($indexes = $db->select('CubeCart_inventory', array('product_id', 'image'))) {
	foreach ($indexes as $index) {
		
		if (empty($index['image'])) continue;
		
		$product_id	= (int)$index['product_id'];
		
		$filename = basename($index['image']);
		$filepath = str_replace($filename,'',$index['image']);
		
		unset($where);
		
		if(empty($filepath)) {
			$where = "`filepath` IS NULL AND `filename` = '$filename'";
		} else {
			$where['filepath'] = $filepath;
			$where['filename'] = $filename;
		}
		
		if ($reference = $db->select('CubeCart_filemanager','file_id',$where)) {
			$record = array(
				'file_id'		=> $reference[0]['file_id'],
				'product_id'	=> $product_id,
				'main_img'		=> '1'
			);
			if (!$db->select('CubeCart_image_index', false, array('product_id' => $record['product_id'], 'file_id' => $record['file_id']))) {
				$db->insert('CubeCart_image_index', $record);
			}
		}
	}
}
## Insert email templates
$GLOBALS['db']->parseSchema(file_get_contents('db'.CC_DS.'install'.CC_DS.'email.sql', false));